//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//       _____________________      _____________________                    ____________________     ____                        ____
//      /                     \    /                     \                  /                    \   |    \                      /    |
//      |      _______________/    |     ___________     |                  |     ___________    |    \    \                    /    /
//      |     /                    |    /           \    |                  |    /           \   |     \    \                  /    /
//      |     |                    |    |           |    |                  |    |           |   |      \    \                /    /
//      |     |                    |    |           |    |                  |    |           |   |       \    \              /    /
//      |     \_______________     |    \___________/    |                  |    \___________/   |        \    \            /    /
//      |                     \    |                     |                  |                    |         \    \          /    /
//      \______________       |    |     ___________     |                  |     _____     _____/          \    \        /    /
//                     \      |    |    |           |    |                  |    |     \    \                \    \      /    /
//                     |      |    |    |           |    |                  |    |      \    \                \    \____/    /
//                     |      |    |    |           |    |                  |    |       \    \                \            /
//       ______________/      |    |    |           |    |   ____________   |    |        \    \                \          /
//      /                     |    |    |           |    |  |            |  |    |         \    \                \        /
//      \_____________________/    \____/           \____/  |____________|  \____/          \____|                \______/
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//  Do not modify and distrybude this code without permssion!!!
//  
//  SA_DirectX effect file by Makarus:
//  visit http://www.facebook.com/sadirectx
//        https://www.youtube.com/channel/UCrASy-x5DgwHpYiDv41RL2Q
//
//  Team:
//
//  Ethmods:
//  visit http://www.facebook.com/Ethmods-2264724780438107
//        https://m.youtube.com/channel/UCqscbzXtZxyYdTeFWowXSRA
//
//  CodeSauce
//  visit https://www.youtube.com/user/keroroxzz
//
//  Sacs Developer
//  visit https://www.youtube.com/channel/UCf5Lt2tllb0EvOqgSJOr-Vw
//
//  Z1mmer
//  visit https://www.facebook.com/ZimmerModd1ng/
//
//  ENBSeries effect file
//  visit http://enbdev.com for updates
//  Copyright (c) 2007-2020 Boris Vorontsov
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



//+++++++++++++++++++++++++++++
//internal parameters, can be modified
//+++++++++++++++++++++++++++++
//none



//+++++++++++++++++++++++++++++
//external parameters, do not modify
//+++++++++++++++++++++++++++++
//keyboard controlled temporary variables (in some versions exists in the config file). Press and hold key 1,2,3...8 together with PageUp or PageDown to modify. By default all set to 1.0
float4	tempF1; //0,1,2,3
float4	tempF2; //5,6,7,8
float4	tempF3; //9,0
//x=Width, y=1/Width, z=ScreenScaleY, w=1/ScreenScaleY
float4	ScreenSize;
//changes in range 0..1, 0 means that night time, 1 - day time
float	ENightDayFactor;
//changes 0 or 1. 0 means that exterior, 1 - interior
float	EInteriorFactor;
//.x - current weather index, .y - incoming weather index, .z - weather transition, .w - time of the day in 24 standart hours. Weather index is value from _weatherlist.ini, for example WEATHER002 means index==2, but index==0 means that weather not captured.
float4	WeatherAndTime;
//x=generic timer in range 0..1, period of 16777216 ms (4.6 hours), w=frame time elapsed (in seconds)
float4	Timer;
//additional info for computations
//float4	TempParameters; 
//fov in degrees
float	FieldOfView;
//time in 0..24 format
float	GameTime;
//sun direction in world space
float4	SunDirection; //.w - 1 when sun is set
//constants set in enbhelper.dll, can be anything captured from game
float4	CustomShaderConstants1[8];


//transposed transform matrix view*projection and inverse of it
float4	MatrixVP[4];
float4	MatrixInverseVP[4];
float4	MatrixVPRotation[4];
float4	MatrixInverseVPRotation[4];
float4	MatrixView[4];
float4	MatrixInverseView[4];
float4	CameraPosition;


float4x4	MatrixWVP;
float4x4	MatrixWVPInverse;
float4x4	MatrixWorld;
float4x4	MatrixProj;
float4	FogParam; //x - nearclip, y - farclip, z - fog start, w - fog end
float4	FogFarColor;



texture2D texNoise;


sampler2D SamplerNoise = sampler_state
{
	Texture = <texNoise>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;//NONE;
	AddressU = Mirror;
	AddressV = Mirror;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;
};


struct VS_INPUT
{
	float3	pos : POSITION;
	float4	diff : COLOR0;
};

struct VS_OUTPUT
{
	float4	pos : POSITION;
	float4	diff : COLOR0;
	float4	vposition : TEXCOORD6;
};



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
VS_OUTPUT	VS_Draw(VS_INPUT IN)
{
    VS_OUTPUT OUT;

	float4	pos=float4(IN.pos.x,IN.pos.y,IN.pos.z,1.0);

	float4	tpos=mul(pos, MatrixWVP);

	OUT.diff=IN.diff;
	OUT.pos=tpos;
	OUT.vposition=tpos;

    return OUT;
}

float4 	WorldPos(in float2 coord)
{
 	const float	depth=1.0;  
   
   float4 tvec; 
          tvec.xy = coord.xy*2.0-1.0;   
          tvec.y = -tvec.y;   
          tvec.z = depth;
          tvec.w = 1.0;
   float4 wpos;
          wpos.x = dot(tvec, MatrixInverseVPRotation[0]);
          wpos.y = dot(tvec, MatrixInverseVPRotation[1]);
          wpos.z = dot(tvec, MatrixInverseVPRotation[2]);
          wpos.w = dot(tvec, MatrixInverseVPRotation[3]);
          wpos.xyz/= wpos.w;
   return wpos;
	
   return wpos;
}

float3 CalculateSun(in float2 coord)
{	  
    float3 sv = SunDirection.xyz;
    float3 sv2 = normalize(float3(-0.0833, -0.946, 0.317));
	
   float t = GameTime;	
	
   float x1 = smoothstep(0.0, 5.0, t);
   float x2 = smoothstep(5.0, 6.0, t);
   float x3 = smoothstep(6.0, 7.0, t);
   float xE = smoothstep(7.0, 12.0, t);
   float x4 = smoothstep(12.0, 18.0, t);
   float xC = smoothstep(18.0, 19.0, t);
   float x5 = smoothstep(19.0, 20.0, t);
   float xG = smoothstep(20.0, 20.5, t);  
   float xZ = smoothstep(20.5, 24.0, t);
   
   float3 t0 = lerp(0.0, 0.0, x1);
          t0 = lerp(t0, float3(0.649, 0.5, 0.255), x2);
          t0 = lerp(t0, float3(0.728, 0.395, 0.104), x3);
          t0 = lerp(t0, float3(0.255, 0.235, 0.224), xE);
          t0 = lerp(t0, float3(0.255, 0.235, 0.224), x4);
          t0 = lerp(t0, float3(0.728, 0.42, 0.138), xC);	 
          t0 = lerp(t0, float3(0.684, 0.297, 0.152), x5);
	  t0 = lerp(t0, float3(0.394, 0.235, 0.21), xG);
	  t0 = lerp(t0, float3(0.0478, 0.0312, 0.0124), xZ);	

   float3 t3 = lerp(0.0, 0.0, x1);
          t3 = lerp(t3, float3(1.0, 0.447, 0.0), x2);
          t3 = lerp(t3, float3(1.0, 0.447, 0.0), x3);
          t3 = lerp(t3, float3(1.0, 1.0, 1.0), xE);
          t3 = lerp(t3, float3(1.0, 1.0, 1.0), x4);
          t3 = lerp(t3, float3(1.0, 0.447, 0.0), xC);		 
          t3 = lerp(t3, float3(1.0, 0.447, 0.0), x5);
	  t3 = lerp(t3, float3(1.0, 0.447, 0.0), xG);
	  t3 = lerp(t3, float3(0.0485, 0.0324, 0.012), xZ);
   
   float4 wp = WorldPos(coord);
   float c0 = 475.0 * 25.0;
   float c1 = 18.0;
   float c2 = 1.0;
   
   float3 np0 = normalize(wp.xyz);
   float factor = (0.01/15.0) - dot(-sv, np0);
         factor = pow(factor, c0);
   float factor1 = 0.06 - dot(-sv, np0);
         factor1 = pow(factor1, c1);	
   float factor2 = 0.6 - dot(-sv, np0);
         factor2 = pow(factor2, c2);
		 
   float factor3 = 0.05 - dot(-sv2, np0);
         factor3 = pow(factor3, c1);	
   float factor4 = 0.6 - dot(-sv2, np0);
         factor4 = pow(factor4, c2);		 
		 
   float3 f0 = factor/12.0;
   float3 f1 = (factor1*factor1)/3.0;    
   float3 f2 = (factor2*factor2)/10.0;
   
   float3 f1x = (factor3*factor3)/5.0;    
   float3 f2x = (factor4*factor4)/10.0;   
   float3 fnight = (f2x*float3(0.0118, 0.0157, 0.0157));
		  fnight*= smoothstep(0.0, 0.3, -np0.y);
   
   float y1 = smoothstep(0.0, 2.0, t);
   float yZ = smoothstep(2.0, 3.0, t);   
   float y2 = smoothstep(4.0, 23.0, t);
   float y3 = smoothstep(23.0, 24.0, t);   
   
  float3 t4 = lerp(0.0, 0.0, y1);
         t4 = lerp(t4, float3(0.231, 0.145, 0.0784), yZ);  
         t4 = lerp(t4, float3(0.231, 0.145, 0.0784), y2);
         t4 = lerp(t4, 0.0, y3);
		 
  float3 t5 = lerp(1.0, 0.5, y1);
         t5 = lerp(t5, 0.0, yZ);  
         t5 = lerp(t5, 0.0, y2);
         t5 = lerp(t5, 1.0, y3);	 
 
   float3 wp0 = wp + CameraPosition;  
   float3 np1 = normalize(wp0.xyz);
   float3 f3 = (f1*t0)+(f2*t3)+(fnight*t5);
 
float3 SunCurrent;
float3 SunNext;
float4 WeatherX = WeatherAndTime;

if (WeatherX.x==0,1) SunCurrent = f3;
if (WeatherX.y==0,1) SunNext = f3;

if (WeatherX.x==4) SunCurrent = 0.0;
if (WeatherX.x==7) SunCurrent = 0.0;
if (WeatherX.x==8) SunCurrent = 0.0;
if (WeatherX.x==9) SunCurrent = 0.0;
if (WeatherX.x==12) SunCurrent = 0.0;
if (WeatherX.x==15) SunCurrent = 0.0;
if (WeatherX.x==16) SunCurrent = 0.0;

if (WeatherX.y==4) SunNext = 0.0;
if (WeatherX.y==7) SunNext = 0.0;
if (WeatherX.y==8) SunNext = 0.0;
if (WeatherX.y==9) SunNext = 0.0;
if (WeatherX.y==12) SunNext = 0.0;
if (WeatherX.y==15) SunNext = 0.0;
if (WeatherX.y==16) SunNext = 0.0;	  

float3 sss2 = lerp(SunCurrent, SunNext, WeatherX.z);	   
 
   return sss2;
}

float CalculateGameTime0(in float t)
{	  
   float x1 = smoothstep(0.0, 5.0, t);
   float x2 = smoothstep(5.0, 6.0, t);
   float x3 = smoothstep(6.0, 7.0, t);
   float xE = smoothstep(7.0, 12.0, t);
   float x4 = smoothstep(12.0, 18.0, t);
   float xC = smoothstep(18.0, 19.0, t);
   float x5 = smoothstep(19.0, 20.0, t);
   float xG = smoothstep(20.0, 20.5, t);  
   float xZ = smoothstep(20.5, 24.0, t);
   
   float3 t0 = lerp(0.0, 0.1, x1);
          t0 = lerp(t0, 0.2, x2);
          t0 = lerp(t0, 0.8, x3);
          t0 = lerp(t0, 1.0, xE);
          t0 = lerp(t0, 1.0, x4);
          t0 = lerp(t0, 0.9, xC);	 
          t0 = lerp(t0, 0.5, x5);
	  t0 = lerp(t0, 0.4, xG);
          t0 = lerp(t0, 0.0, xZ); 		  
   return t0;	  
}

float CalculateGameTime(in float t)
{	  
   float x1 = smoothstep(0.0, 5.0, t);
   float x2 = smoothstep(5.0, 6.0, t);
   float x3 = smoothstep(6.0, 7.0, t);
   float xE = smoothstep(7.0, 12.0, t);
   float x4 = smoothstep(12.0, 18.0, t);
   float xC = smoothstep(18.0, 19.0, t);
   float x5 = smoothstep(19.0, 20.0, t);
   float xG = smoothstep(20.0, 20.5, t);  
   float xZ = smoothstep(20.5, 24.0, t);
   
   float3 t0 = lerp(0.0, 0.1, x1);
          t0 = lerp(t0, 0.7, x2);
          t0 = lerp(t0, 1.0, x3);
          t0 = lerp(t0, 1.0, xE);
          t0 = lerp(t0, 1.0, x4);
          t0 = lerp(t0, 0.9, xC);		 
          t0 = lerp(t0, 0.8, x5);
	  t0 = lerp(t0, 0.6, xG);
	  t0 = lerp(t0, 0.0, xZ); 		  
   return t0;	  
}

float CalculateGameTime2(in float t)
{	  
   float x1 = smoothstep(0.0, 5.0, t);
   float x2 = smoothstep(5.0, 6.0, t);
   float x3 = smoothstep(6.0, 7.0, t);
   float xE = smoothstep(7.0, 12.0, t);
   float x4 = smoothstep(12.0, 18.0, t);
   float xC = smoothstep(18.0, 19.0, t);
   float x5 = smoothstep(19.0, 20.0, t);
   float xG = smoothstep(20.0, 20.5, t);  
   float xZ = smoothstep(20.5, 24.0, t);
   
   float3 t0 = lerp(0.0, 0.0, x1);
          t0 = lerp(t0, 0.7, x2);
          t0 = lerp(t0, 0.9, x3);
          t0 = lerp(t0, 1.0, xE);
          t0 = lerp(t0, 0.5, x4);
          t0 = lerp(t0, 0.5, xC);		 
          t0 = lerp(t0, 1.0, x5);
	  t0 = lerp(t0, 1.0, xG);
	  t0 = lerp(t0, 0.0, xZ);	  
   return t0;	  
}

float3 ColorHorizon(float3 r0, float f)
{	
   float t = GameTime;
   float tf = CalculateGameTime2(t); 
   float df = pow(saturate(SunDirection.z * tf), 1.0);
	float3 sg = lerp(1.0, float3(1.0, 1.0, 1.0), pow(r0.y, 2.2));
	float3 sg2 = lerp(1.0, float3(1.0, 1.0, 1.0), pow(r0.y, 1.15));
	float3 sd = lerp(1.0, float3(1.0, 1.0, 1.0), pow(r0.y, 2.15));
	float3 sd2 = lerp(1.0, float3(1.0, 1.0, 1.0), pow(r0.y, 1.15));
	float3 a = lerp(sg, 1.0, f);	
	float3 a2 = lerp(sg2, 1.0, f);
	float3 ad = lerp(sd, 1.0, f);	
	float3 ad2 = lerp(sd2, 1.0, f);
	r0 *= lerp(a, 1.0, df);	
	r0 *= lerp(a2, 1.0, df);
	float3 d1 = lerp(1.0, ad, df);
	float3 d2 = lerp(1.0, ad2, df);
    r0 *= d1*d2;				
   return r0;
}

float3 ColorTop()
{	
float3   cc = float3(1.0, 1.0, 1.0);
float3   cn = float3(1.0, 1.0, 1.0);

float x1 = smoothstep(1.0, 2.0,  WeatherAndTime);
   
float4 WeatherX = WeatherAndTime;

if (WeatherX.x==0,1) cc = float3(0.333, 0.51, 0.824);
if (WeatherX.y==0,1) cn = float3(0.333, 0.51, 0.824);

float3 skyW = 1;

if (WeatherX.x==4) cc = skyW;
if (WeatherX.x==7) cc = skyW;
if (WeatherX.x==8) cc = skyW;
if (WeatherX.x==9) cc = skyW;
if (WeatherX.x==12) cc = skyW;
if (WeatherX.x==15) cc = skyW;
if (WeatherX.x==16) cc = skyW;

if (WeatherX.y==4) cn = skyW;
if (WeatherX.y==7) cn = skyW;
if (WeatherX.y==8) cn = skyW;
if (WeatherX.y==9) cn = skyW;
if (WeatherX.y==12) cn = skyW;
if (WeatherX.y==15) cn = skyW;
if (WeatherX.y==16) cn = skyW;

float3 sss = lerp(cc, cn, WeatherX.z);

return sss;
}

float 	CalculateLuminance(in float3 color)
{
	return (color.r * 0.2126f + color.g * 0.7152f + color.b * 0.0722f);
}

float4 PS_Draw(VS_OUTPUT IN, float2 vPos : VPOS) : COLOR
{
   float t = GameTime;	
   float tf = CalculateGameTime(t);   
   float tf2 = CalculateGameTime0(t);    
   
 	float2	coord=vPos.xy*ScreenSize.y;
	        coord.y*=ScreenSize.z;  
   
   float4 r0 = 1.0;
   float4 wpos = WorldPos(coord);
   float3 colorS = ColorTop();  

   float4 w0 = wpos+CameraPosition;
   float4 cam = CameraPosition; 
   float p2 = length(wpos.xyz);  
	 	  
   float4 np0 = float4(normalize(wpos.xyz), 1.0);
	      np0.xyz = normalize(w0.xyz-float3(cam.xy, 0.0));	
		  
   float3 vec = normalize(float3(0.0, 0.0, 1.0));	  
   float3 hv = normalize(-vec+np0);
   float sgf = dot(hv, np0);    
   
	if (dot(hv, np0) > 0.75)
		  sgf = 1.5 - sgf;
	float curve = 5.0f;	
	      sgf = pow(sgf, curve);  

	float3 d1 = 1.0f;	
 		   d1 = CalculateLuminance(d1) * colorS;
		   d1 *= pow(sgf, 2.0f) + 0.5f;
		   d1 *= (sgf * 20.0f) + 1.0f;
			   
   float3 sun = CalculateSun(coord);		   
   float3 d2 = ColorHorizon(d1, sgf);
   
	d1 = d2;
	d1*= lerp(0.0, 1.0, tf);
	float3 n0 = normalize(d1.xyz);
	float3 ct0=d1.xyz/n0.xyz;
	ct0=pow(ct0, 0.7);
    n0.xyz = pow(n0.xyz, 0.62);   
    d1.xyz = ct0*n0.xyz;
    d1.xyz*= 1.0;  
	
    float np4 = (np0.z * (2.0)) + 0.40;
	      np4 *= lerp(0.0, 1.0, tf2);  		  
    float3 a = d1+sun;
	
    float3 a2 = np4;
    float3   sc = 1.0;
    float3   sn = 1.0;   
    float4 wx = WeatherAndTime;	
    if (wx.x==0,1) sc = a*0.6;
    if (wx.y==0,1) sn = a*0.6;   
    if (wx.x==4) sc = a;
    if (wx.x==7) sc = a;
    if (wx.x==8) sc = a2;
    if (wx.x==9) sc = a2;
    if (wx.x==12) sc = a2;
    if (wx.x==15) sc = a2;
    if (wx.x==16) sc = a2;
    if (wx.y==4) sn = a;
    if (wx.y==7) sn = a;
    if (wx.y==8) sn = a2;
    if (wx.y==9) sn = a2;
    if (wx.y==12) sn = a2;
    if (wx.y==15) sn = a2;
    if (wx.y==16) sn = a2;
    float3 sss = lerp(sc, sn, wx.z);			
    r0.xyz = sss;	

	r0.w=1.0;  
	return r0;

}



//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
technique Draw
{
    pass p0
    {
	VertexShader = compile vs_3_0 VS_Draw();
	PixelShader  = compile ps_3_0 PS_Draw();
	}
}


